<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class SolicitacaoFactory {

    use TQuery;
    protected $entityManager;
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function getLocalRequest($params) {
        $sqlCode = "SELECT FCM_LOCALCLI.NRLOCALCLIENTE, FCM_LOCALCLI.NMLOCALCLIENTE,
                           FCM_LOCALCLI.NRSETOR, FCM_LOCALCLI.NRLOCALCLIENTEPAI
                     FROM FCM_LOCALCLI
                     JOIN FCM_TIPOLOCALCLI
                       ON FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
                    WHERE FCM_TIPOLOCALCLI.IDTIPOLOCALCLI = ".$params["parent"];

        $std = $this->connection->prepare($sqlCode);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function insertNewRequest($params) {

      $sql="INSERT INTO FCM_SOLICITACAO (NRSOLICITACAO, NMSOLICITACAO, DTSOLICITACAO, IDSITUACAO, NRLOCALCLIENTE,
            CDOPERABERTURA, DSSOLICITACAO, NRORG, IDATIVO, DTINCLUSAO)
              VALUES (:NRSOLICITACAO, :NMSOLICITACAO, SYSDATE, :IDSITUACAO, :NRLOCALCLIENTE, :CDOPERABERTURA,
                      :DSSOLICITACAO, :NRORG, 'S', SYSDATE)";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function insertRequestHistory($params) {

      $sql="INSERT INTO FCM_SOLICITACAOHISTORICO (NRSOLICITACAOHISTORICO, NRSOLICITACAO, DTHISTSOLICITACAO,
            IDSITUACAO, IDTIPOHISTORICO, CDOPERSOLICITANTE, DSSOLICITACAO, IDSATISFACAOSOLICITA, NRORG, IDATIVO)
              VALUES (:NRSOLICITACAOHISTORICO, :NRSOLICITACAO, SYSDATE, :IDSITUACAO, :IDTIPOHISTORICO,
              :CDOPERSOLICITANTE, :DSSOLICITACAO, :IDSATISFACAOSOLICITA, :NRORG, 'S')";

        $std = $this->connection->prepare($sql);
        $std->execute($params);

    }

    public function getSituationRequest() {

        $sql = "SELECT DISTINCT S.IDSITUACAO AS NRIDSITUACAO,
                  CASE S.IDSITUACAO WHEN '1' THEN 'Pendente'
                     WHEN '2' THEN 'Em andamento'
                     WHEN '3' THEN 'Aguardando Avaliação'
                     WHEN '4' THEN 'Concluído'
                     ELSE NULL END AS IDSITUACAO
                     FROM FCM_SOLICITACAO S";

        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function getNameRequest() {

        $sql = "SELECT S.NMSOLICITACAO, S.NRSOLICITACAO
                  FROM FCM_SOLICITACAO S";

        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function getCardsRequests($parametros, $usersIds) {

        $sql = "SELECT S.NRSOLICITACAO, S.NMSOLICITACAO, TO_CHAR(S.DTSOLICITACAO, 'DD/MM HH24:MI') DTSOLICITACAO, S.NRLOCALCLIENTE, S.IDSITUACAO, LC.NMLOCALCLIENTE,
                  CASE S.IDSITUACAO
                    WHEN '1' THEN 'Pendente'
                    WHEN '2' THEN  'Em andamento'
                    WHEN '3' THEN 'Aguardando Avaliação'
                    WHEN '4' THEN 'Concluído'
                    ELSE NULL END AS IDSITUACAO
                 FROM FCM_SOLICITACAO S
                 JOIN FCM_LOCALCLI LC
                   ON LC.NRLOCALCLIENTE = S.NRLOCALCLIENTE
                   WHERE S.CDOPERABERTURA IN ({$usersIds})"."$parametros ORDER BY DTSOLICITACAO DESC";

        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();

    }

    public function showRequest($param) {

        $sql = "SELECT S.NRSOLICITACAO, S.NMSOLICITACAO, S.DSSOLICITACAO, TO_CHAR(S.DTSOLICITACAO, 'DD/MM HH24:MI') DTSOLICITACAO, S.NRLOCALCLIENTE, S.IDSITUACAO, LC.NMLOCALCLIENTE,
                    CASE S.IDSITUACAO
                    WHEN '1' THEN 'Pendente'
                    WHEN '2' THEN  'Em andamento'
                    WHEN '3' THEN 'Aguardando Avaliação'
                    WHEN '4' THEN 'Concluído'
                    ELSE NULL END AS IDSITUACAO
                FROM FCM_SOLICITACAO S
                JOIN FCM_LOCALCLI LC
                ON LC.NRLOCALCLIENTE = S.NRLOCALCLIENTE
                WHERE S.NRSOLICITACAO = :NRSOLICITACAO";

        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetchAll();

    }

    public function upRequest($parametros) {

        $sql = "UPDATE FCM_SOLICITACAO
                  SET IDSITUACAO = :IDSITUACAO,
                      DSSOLICITACAO = :DSSOLICITACAO
                WHERE NRSOLICITACAO = :NRSOLICITACAO";

        $std = $this->connection->prepare($sql);
        $std->execute($parametros);
    }
    
    public function insertImg($param){
        $sql="INSERT INTO FCM_IMGSOLICITACAO (NRIMGSOLICITACAO, NRSOLICITACAO, DSCAMINHO, NRORG, IDATIVO, DSTYPE, NRSIZE, CDOPERINCLUSAO, DTINCLUSAO)
              VALUES (:NRIMGSOLICITACAO, :NRSOLICITACAO, :DSCAMINHO, :NRORG, 'S', :DSTYPE, :NRSIZE, :CDOPERINCLUSAO, SYSDATE)";
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
    
}
?>