/* Tecnisa - Tecnologia em Informtica

Nome: 9002_CTBSTP_ATUALIZA_SALDO_COMERCIAL.SQL

Descrio:
 Procedimento para atualizao do saldo comercial (VRLANCTOEST).

Criao:
__/__/__ - ___________________________

Manutenes:
23/11/99 Paulo Giovanni - Converso p/ SQL-SERVER
__/__/__ _________ - _____________________________________________
__/__/__ _________ - _____________________________________________
__/__/__ _________ - _____________________________________________
*/

IF EXISTS(SELECT name FROM sysobjects
          WHERE name = 'ATUALIZA_SALDO_COMERCIAL' AND type = 'P')
  DROP PROCEDURE ATUALIZA_SALDO_COMERCIAL
  GO

CREATE PROCEDURE ATUALIZA_SALDO_COMERCIAL
                            @P_CDEMPRESA varchar(2)

AS
   /*incio das variveis do cursor C_LANCCOME*/
   DECLARE @V_CDEMPRESA    varchar(2);

   DECLARE @V_IDLANCSALDO  varchar(1);
   DECLARE @V_VRLANCAMENT  numeric(16,2);
   DECLARE @V_CDEMPRESA_B  varchar(2);
   DECLARE @V_CDCONTCTBL_B varchar(20);
   DECLARE @V_DTSALDCOME   datetime;
   DECLARE @V_VRSALDCOME   numeric(16,2);
   /*fim das variveis do cursor C_LANCCOME*/

   DECLARE @VRSALDO_ANT     NUMERIC(15,6);
   DECLARE @V_DTFINACONT    DATETIME;
   DECLARE @V_DATAINIC      DATETIME;
   DECLARE @DATA_SALDO_ANT  DATETIME;
   DECLARE @DATA_MAX        DATETIME;
   DECLARE @V_CONTSALDO     VARCHAR(1);
   DECLARE @V_IDSALDEMPR    VARCHAR(1);

   /*incio das variveis do cursor SOMACONTA*/
   DECLARE @V_IDLANCCOME varchar(1);
   DECLARE @V_CDCONTCOME varchar(21);
   DECLARE @V_CDCONTCTBL varchar(20);
   DECLARE @V_DTLANCCONT datetime;
   DECLARE @V_LAST_DTLANC DATETIME;
   DECLARE @V_VALORSALDO numeric(16,2);
   /*fim das variveis do cursor SOMACONTA*/

   /*incio das variveis do cursor SOMACONTA*/
   DECLARE @V_NRSEQLANCOM  VARCHAR(10);
   /*fim das variveis do cursor SOMACONTA*/


BEGIN

	SELECT @V_DATAINIC = MIN(DTLANCCONT)
   FROM LANCCONT
	WHERE (LANCCONT.CDEMPRESA   = @P_CDEMPRESA) AND
         (LANCCONT.IDLANCSALDO = 'N');

   DECLARE C_LANCCOME CURSOR FOR
   SELECT LANCCONT.CDEMPRESA,LANCCONT.CDCONTCTBL,IDLANCSALDO,VRLANCAMENT,
          SALDCOME.CDEMPRESA, SALDCOME.CDCONTCTBL,DTSALDCOME,VRSALDCOME
   FROM   LANCCONT, SALDCOME, CONTCTBL WITH (UPDLOCK)
   WHERE (LANCCONT.CDEMPRESA   = @P_CDEMPRESA) AND
         (LANCCONT.IDLANCSALDO = 'N') AND
         (SALDCOME.CDEMPRESA   = @P_CDEMPRESA) AND
         (LANCCONT.CDCONTCTBL  = SALDCOME.CDCONTCTBL) AND
         (LANCCONT.CDCONTCOME  = SALDCOME.CDSALDCOME) AND
         (SALDCOME.DTSALDCOME >= @V_DATAINIC)         AND
         (LANCCONT.CDCONTCTBL  = CONTCTBL.CDCONTCTBL) AND
         (CONTCTBL.IDCONTCCUS <> 'R');

   OPEN C_LANCCOME;
   CLOSE C_LANCCOME;


   DECLARE C_LANCDEL CURSOR FOR
      SELECT LANCOMEEX.NRSEQLANCOM
        FROM LANCOMEEX, CONTCTBL
       WHERE (LANCOMEEX.CDEMPRESA    =  @P_CDEMPRESA) AND
             (LANCOMEEX.DTLANCCONCOM >= @V_DATAINIC) AND
             (LANCOMEEX.CDCONTALACOM = CONTCTBL.CDCONTCTBL) AND
             (CONTCTBL.IDCONTCCUS <> 'R')

   OPEN C_LANCDEL;
   CLOSE C_LANCDEL;

   DECLARE SOMACONTA CURSOR FOR
	(SELECT IDLANCCOME,CDCONTCOME,CDCONTCTBL, DTLANCCONT, SUM(LANCCONT.VRLANCAMENT) AS VALORSALDO
	 FROM LANCCONT
	 WHERE (LANCCONT.CDEMPRESA  = @P_CDEMPRESA) AND
          (LANCCONT.IDLANCSALDO = 'N') AND
          (LANCCONT.CDCONTCOME IS NOT NULL)
	 GROUP BY IDLANCCOME,CDCONTCOME,CDCONTCTBL,DTLANCCONT ) ;

    OPEN SOMACONTA;

    FETCH NEXT FROM SOMACONTA INTO @V_IDLANCCOME, @V_CDCONTCOME,
                                   @V_CDCONTCTBL, @V_DTLANCCONT,
                                   @V_VALORSALDO ;

   WHILE (@@FETCH_STATUS = 0)
   BEGIN
          SELECT @V_CONTSALDO = COUNT(*)
          FROM  SALDCOME
          WHERE (SALDCOME.CDEMPRESA  = @P_CDEMPRESA) AND
                (SALDCOME.IDSALDCOME = @V_IDLANCCOME) AND
                (SALDCOME.CDSALDCOME = @V_CDCONTCOME) AND
	             (SALDCOME.CDCONTCTBL = @V_CDCONTCTBL) AND
                (SALDCOME.DTSALDCOME IN (SELECT MAX(DTSALDCOME)
                                         FROM SALDCOME
                                         WHERE (SALDCOME.CDEMPRESA  = @P_CDEMPRESA) AND
                                               (SALDCOME.IDSALDCOME = @V_IDLANCCOME) AND
                                               (SALDCOME.CDSALDCOME = @V_CDCONTCOME) AND
                                               (SALDCOME.CDCONTCTBL = @V_CDCONTCTBL) AND
                                               (SALDCOME.DTSALDCOME < @V_DTLANCCONT)));
          IF (@V_CONTSALDO > 0)
          BEGIN
             SELECT @DATA_SALDO_ANT = DTSALDCOME, @VRSALDO_ANT = VRSALDCOME
             FROM SALDCOME
	          WHERE (SALDCOME.CDEMPRESA  = @P_CDEMPRESA) AND
                   (SALDCOME.IDSALDCOME = @V_IDLANCCOME) AND
                   (SALDCOME.CDSALDCOME = @V_CDCONTCOME) AND
	                (SALDCOME.CDCONTCTBL = @V_CDCONTCTBL) AND
                   (SALDCOME.DTSALDCOME IN (SELECT MAX(DTSALDCOME)
                                            FROM SALDCOME
                                            WHERE (SALDCOME.CDEMPRESA  = @P_CDEMPRESA) AND
                                                  (SALDCOME.IDSALDCOME = @V_IDLANCCOME) AND
                                                  (SALDCOME.CDSALDCOME = @V_CDCONTCOME) AND
	                                               (SALDCOME.CDCONTCTBL = @V_CDCONTCTBL) AND
                                                  (SALDCOME.DTSALDCOME < @V_DTLANCCONT)));
          END
          ELSE
          BEGIN
              SET @VRSALDO_ANT = 0;
          END;

       SET  @V_LAST_DTLANC = @V_DTLANCCONT;
       EXEC ULTIMO_DIA_MES @P_DTDATA = @V_LAST_DTLANC OUTPUT;
	    SELECT @V_CONTSALDO = COUNT(*)
       FROM SALDCOME
		 WHERE (SALDCOME.CDEMPRESA  = @P_CDEMPRESA) AND
             (SALDCOME.IDSALDCOME = @V_IDLANCCOME) AND
             (SALDCOME.CDSALDCOME = @V_CDCONTCOME) AND
		       (SALDCOME.CDCONTCTBL = @V_CDCONTCTBL) AND
             (SALDCOME.DTSALDCOME = @V_LAST_DTLANC);

          IF (@V_CONTSALDO = 0)
          BEGIN
              INSERT INTO SALDCOME
	               (CDEMPRESA, IDSALDCOME, CDSALDCOME, CDCONTCTBL, DTSALDCOME, VRSALDCOME)
	               VALUES
                     (@P_CDEMPRESA, @V_IDLANCCOME, @V_CDCONTCOME, @V_CDCONTCTBL,
                      @V_LAST_DTLANC, (@V_VALORSALDO + @VRSALDO_ANT));
          END
          ELSE
          BEGIN
             SET @V_LAST_DTLANC = @V_DTLANCCONT;
             EXEC ULTIMO_DIA_MES @P_DTDATA = @V_LAST_DTLANC OUTPUT;
          	 UPDATE SALDCOME SET VRSALDCOME = SALDCOME.VRSALDCOME + @V_VALORSALDO
			    WHERE (SALDCOME.DTSALDCOME = @V_LAST_DTLANC) AND
                   (SALDCOME.CDEMPRESA  = @P_CDEMPRESA) AND
                   (SALDCOME.IDSALDCOME = @V_IDLANCCOME) AND
                   (SALDCOME.CDSALDCOME = @V_CDCONTCOME) AND
				       (SALDCOME.CDCONTCTBL = @V_CDCONTCTBL);
          END;

          SELECT @DATA_MAX = MAX(DTSALDCOME)
          FROM SALDCOME
          WHERE (SALDCOME.CDEMPRESA  = @P_CDEMPRESA) AND
                (SALDCOME.IDSALDCOME = @V_IDLANCCOME) AND
                (SALDCOME.CDSALDCOME = @V_CDCONTCOME) AND
		          (SALDCOME.CDCONTCTBL = @V_CDCONTCTBL);

          IF (@DATA_MAX > @V_DTLANCCONT)
          BEGIN
             SET @V_LAST_DTLANC = @V_DTLANCCONT;
             EXEC ULTIMO_DIA_MES @P_DTDATA = @V_LAST_DTLANC OUTPUT;
             UPDATE SALDCOME SET VRSALDCOME = VRSALDCOME + @V_VALORSALDO
	          WHERE (SALDCOME.DTSALDCOME > @V_LAST_DTLANC) AND
                   (SALDCOME.CDEMPRESA  = @P_CDEMPRESA) AND
                   (SALDCOME.IDSALDCOME = @V_IDLANCCOME) AND
                   (SALDCOME.CDSALDCOME = @V_CDCONTCOME) AND
			          (SALDCOME.CDCONTCTBL = @V_CDCONTCTBL);
          END;

          FETCH NEXT FROM SOMACONTA INTO @V_IDLANCCOME, @V_CDCONTCOME,
                                         @V_CDCONTCTBL, @V_DTLANCCONT,
                                         @V_VALORSALDO ;
  	END;

   CLOSE SOMACONTA ;
   DEALLOCATE SOMACONTA ;
   DEALLOCATE C_LANCCOME ;

END;
GO
